// ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom-params-data.h"
#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom-shared-message-ids.h"

#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom-import-headers.h"


#ifndef UI_OZONE_PUBLIC_MOJOM_WAYLAND_WAYLAND_BUFFER_MANAGER_MOJOM_JUMBO_H_
#define UI_OZONE_PUBLIC_MOJOM_WAYLAND_WAYLAND_BUFFER_MANAGER_MOJOM_JUMBO_H_
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#include "ui/gfx/mojom/accelerated_widget_mojom_traits.h"
#include "ui/gfx/mojom/presentation_feedback_mojom_traits.h"
#include "ui/gfx/mojom/swap_result_mojom_traits.h"
#endif
namespace ui {
namespace ozone {
namespace mojom {
const char WaylandBufferManagerHost::Name_[] = "ui.ozone.mojom.WaylandBufferManagerHost";

WaylandBufferManagerHostProxy::WaylandBufferManagerHostProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WaylandBufferManagerHostProxy::SetWaylandBufferManagerGpu(
    mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> in_buffer_manager_gpu_associated) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerHost::SetWaylandBufferManagerGpu");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerHost_SetWaylandBufferManagerGpu_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerHost_SetWaylandBufferManagerGpu_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::ui::ozone::mojom::WaylandBufferManagerGpuAssociatedPtrInfoDataView>(
      in_buffer_manager_gpu_associated, &params->buffer_manager_gpu_associated, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->buffer_manager_gpu_associated),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid buffer_manager_gpu_associated in WaylandBufferManagerHost.SetWaylandBufferManagerGpu request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerHost::Name_);
  message.set_method_name("SetWaylandBufferManagerGpu");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerHostProxy::CreateDmabufBasedBuffer(
    mojo::PlatformHandle in_dmabuf_fd, const ::gfx::Size& in_size, const std::vector<uint32_t>& in_strides, const std::vector<uint32_t>& in_offsets, const std::vector<uint64_t>& in_modifiers, uint32_t in_format, uint32_t in_planes_count, uint32_t in_buffer_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerHost::CreateDmabufBasedBuffer");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerHost_CreateDmabufBasedBuffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerHost_CreateDmabufBasedBuffer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::PlatformHandle>(
      in_dmabuf_fd, &params->dmabuf_fd, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->dmabuf_fd),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid dmabuf_fd in WaylandBufferManagerHost.CreateDmabufBasedBuffer request");
  typename decltype(params->size)::BaseType::BufferWriter
      size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_size, buffer, &size_writer, &serialization_context);
  params->size.Set(
      size_writer.is_null() ? nullptr : size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null size in WaylandBufferManagerHost.CreateDmabufBasedBuffer request");
  typename decltype(params->strides)::BaseType::BufferWriter
      strides_writer;
  const mojo::internal::ContainerValidateParams strides_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint32_t>>(
      in_strides, buffer, &strides_writer, &strides_validate_params,
      &serialization_context);
  params->strides.Set(
      strides_writer.is_null() ? nullptr : strides_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->strides.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null strides in WaylandBufferManagerHost.CreateDmabufBasedBuffer request");
  typename decltype(params->offsets)::BaseType::BufferWriter
      offsets_writer;
  const mojo::internal::ContainerValidateParams offsets_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint32_t>>(
      in_offsets, buffer, &offsets_writer, &offsets_validate_params,
      &serialization_context);
  params->offsets.Set(
      offsets_writer.is_null() ? nullptr : offsets_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->offsets.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null offsets in WaylandBufferManagerHost.CreateDmabufBasedBuffer request");
  typename decltype(params->modifiers)::BaseType::BufferWriter
      modifiers_writer;
  const mojo::internal::ContainerValidateParams modifiers_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint64_t>>(
      in_modifiers, buffer, &modifiers_writer, &modifiers_validate_params,
      &serialization_context);
  params->modifiers.Set(
      modifiers_writer.is_null() ? nullptr : modifiers_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->modifiers.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null modifiers in WaylandBufferManagerHost.CreateDmabufBasedBuffer request");
  params->format = in_format;
  params->planes_count = in_planes_count;
  params->buffer_id = in_buffer_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerHost::Name_);
  message.set_method_name("CreateDmabufBasedBuffer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerHostProxy::CreateShmBasedBuffer(
    mojo::PlatformHandle in_shm_fd, uint64_t in_length, const ::gfx::Size& in_size, uint32_t in_buffer_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerHost::CreateShmBasedBuffer");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerHost_CreateShmBasedBuffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerHost_CreateShmBasedBuffer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::PlatformHandle>(
      in_shm_fd, &params->shm_fd, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->shm_fd),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid shm_fd in WaylandBufferManagerHost.CreateShmBasedBuffer request");
  params->length = in_length;
  typename decltype(params->size)::BaseType::BufferWriter
      size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_size, buffer, &size_writer, &serialization_context);
  params->size.Set(
      size_writer.is_null() ? nullptr : size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null size in WaylandBufferManagerHost.CreateShmBasedBuffer request");
  params->buffer_id = in_buffer_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerHost::Name_);
  message.set_method_name("CreateShmBasedBuffer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerHostProxy::DestroyBuffer(
    ::gfx::AcceleratedWidget in_widget, uint32_t in_buffer_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerHost::DestroyBuffer");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerHost_DestroyBuffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerHost_DestroyBuffer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in WaylandBufferManagerHost.DestroyBuffer request");
  params->buffer_id = in_buffer_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerHost::Name_);
  message.set_method_name("DestroyBuffer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerHostProxy::CommitBuffer(
    ::gfx::AcceleratedWidget in_widget, uint32_t in_buffer_id, const ::gfx::Rect& in_damage_region) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerHost::CommitBuffer");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerHost_CommitBuffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerHost_CommitBuffer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in WaylandBufferManagerHost.CommitBuffer request");
  params->buffer_id = in_buffer_id;
  typename decltype(params->damage_region)::BaseType::BufferWriter
      damage_region_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_damage_region, buffer, &damage_region_writer, &serialization_context);
  params->damage_region.Set(
      damage_region_writer.is_null() ? nullptr : damage_region_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->damage_region.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null damage_region in WaylandBufferManagerHost.CommitBuffer request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerHost::Name_);
  message.set_method_name("CommitBuffer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool WaylandBufferManagerHostStubDispatch::Accept(
    WaylandBufferManagerHost* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kWaylandBufferManagerHost_SetWaylandBufferManagerGpu_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::SetWaylandBufferManagerGpu",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::SetWaylandBufferManagerGpu");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerHost_SetWaylandBufferManagerGpu_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerHost_SetWaylandBufferManagerGpu_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> p_buffer_manager_gpu_associated{};
      WaylandBufferManagerHost_SetWaylandBufferManagerGpu_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_buffer_manager_gpu_associated =
            input_data_view.TakeBufferManagerGpuAssociated<decltype(p_buffer_manager_gpu_associated)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerHost::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetWaylandBufferManagerGpu(
std::move(p_buffer_manager_gpu_associated));
      return true;
    }
    case internal::kWaylandBufferManagerHost_CreateDmabufBasedBuffer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CreateDmabufBasedBuffer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CreateDmabufBasedBuffer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerHost_CreateDmabufBasedBuffer_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerHost_CreateDmabufBasedBuffer_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PlatformHandle p_dmabuf_fd{};
      ::gfx::Size p_size{};
      std::vector<uint32_t> p_strides{};
      std::vector<uint32_t> p_offsets{};
      std::vector<uint64_t> p_modifiers{};
      uint32_t p_format{};
      uint32_t p_planes_count{};
      uint32_t p_buffer_id{};
      WaylandBufferManagerHost_CreateDmabufBasedBuffer_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_dmabuf_fd = input_data_view.TakeDmabufFd();
      if (success && !input_data_view.ReadSize(&p_size))
        success = false;
      if (success && !input_data_view.ReadStrides(&p_strides))
        success = false;
      if (success && !input_data_view.ReadOffsets(&p_offsets))
        success = false;
      if (success && !input_data_view.ReadModifiers(&p_modifiers))
        success = false;
      if (success)
        p_format = input_data_view.format();
      if (success)
        p_planes_count = input_data_view.planes_count();
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerHost::Name_, 888954649, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateDmabufBasedBuffer(
std::move(p_dmabuf_fd), 
std::move(p_size), 
std::move(p_strides), 
std::move(p_offsets), 
std::move(p_modifiers), 
std::move(p_format), 
std::move(p_planes_count), 
std::move(p_buffer_id));
      return true;
    }
    case internal::kWaylandBufferManagerHost_CreateShmBasedBuffer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CreateShmBasedBuffer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CreateShmBasedBuffer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerHost_CreateShmBasedBuffer_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerHost_CreateShmBasedBuffer_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PlatformHandle p_shm_fd{};
      uint64_t p_length{};
      ::gfx::Size p_size{};
      uint32_t p_buffer_id{};
      WaylandBufferManagerHost_CreateShmBasedBuffer_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success)
        p_shm_fd = input_data_view.TakeShmFd();
      if (success)
        p_length = input_data_view.length();
      if (success && !input_data_view.ReadSize(&p_size))
        success = false;
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerHost::Name_, 1892823448, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateShmBasedBuffer(
std::move(p_shm_fd), 
std::move(p_length), 
std::move(p_size), 
std::move(p_buffer_id));
      return true;
    }
    case internal::kWaylandBufferManagerHost_DestroyBuffer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::DestroyBuffer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::DestroyBuffer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerHost_DestroyBuffer_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerHost_DestroyBuffer_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::gfx::AcceleratedWidget p_widget{};
      uint32_t p_buffer_id{};
      WaylandBufferManagerHost_DestroyBuffer_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadWidget(&p_widget))
        success = false;
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerHost::Name_, 1911540030, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DestroyBuffer(
std::move(p_widget), 
std::move(p_buffer_id));
      return true;
    }
    case internal::kWaylandBufferManagerHost_CommitBuffer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CommitBuffer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerHost::CommitBuffer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerHost_CommitBuffer_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerHost_CommitBuffer_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::gfx::AcceleratedWidget p_widget{};
      uint32_t p_buffer_id{};
      ::gfx::Rect p_damage_region{};
      WaylandBufferManagerHost_CommitBuffer_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadWidget(&p_widget))
        success = false;
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (success && !input_data_view.ReadDamageRegion(&p_damage_region))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerHost::Name_, 1799175654, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CommitBuffer(
std::move(p_widget), 
std::move(p_buffer_id), 
std::move(p_damage_region));
      return true;
    }
  }
  return false;
}

// static
bool WaylandBufferManagerHostStubDispatch::AcceptWithResponder(
    WaylandBufferManagerHost* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kWaylandBufferManagerHost_SetWaylandBufferManagerGpu_Name: {
      break;
    }
    case internal::kWaylandBufferManagerHost_CreateDmabufBasedBuffer_Name: {
      break;
    }
    case internal::kWaylandBufferManagerHost_CreateShmBasedBuffer_Name: {
      break;
    }
    case internal::kWaylandBufferManagerHost_DestroyBuffer_Name: {
      break;
    }
    case internal::kWaylandBufferManagerHost_CommitBuffer_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWaylandBufferManagerHostValidationInfo[] = {
    {internal::kWaylandBufferManagerHost_SetWaylandBufferManagerGpu_Name,
     {&internal::WaylandBufferManagerHost_SetWaylandBufferManagerGpu_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerHost_CreateDmabufBasedBuffer_Name,
     {&internal::WaylandBufferManagerHost_CreateDmabufBasedBuffer_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerHost_CreateShmBasedBuffer_Name,
     {&internal::WaylandBufferManagerHost_CreateShmBasedBuffer_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerHost_DestroyBuffer_Name,
     {&internal::WaylandBufferManagerHost_DestroyBuffer_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerHost_CommitBuffer_Name,
     {&internal::WaylandBufferManagerHost_CommitBuffer_Params_Data::Validate,
      nullptr /* no response */}},
};

bool WaylandBufferManagerHostRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::ui::ozone::mojom::WaylandBufferManagerHost::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWaylandBufferManagerHostValidationInfo);
}

const char WaylandBufferManagerGpu::Name_[] = "ui.ozone.mojom.WaylandBufferManagerGpu";

WaylandBufferManagerGpuProxy::WaylandBufferManagerGpuProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void WaylandBufferManagerGpuProxy::Initialize(
    mojo::PendingRemote<WaylandBufferManagerHost> in_remote_host, const base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>>& in_buffer_formats_with_modifiers, bool in_supports_dma_buf) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerGpu::Initialize");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerGpu_Initialize_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerGpu_Initialize_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::ui::ozone::mojom::WaylandBufferManagerHostInterfaceBase>>(
      in_remote_host, &params->remote_host, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->remote_host),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid remote_host in WaylandBufferManagerGpu.Initialize request");
  typename decltype(params->buffer_formats_with_modifiers)::BaseType::BufferWriter
      buffer_formats_with_modifiers_writer;
  const mojo::internal::ContainerValidateParams buffer_formats_with_modifiers_validate_params(
      new mojo::internal::ContainerValidateParams(0, ::gfx::mojom::internal::BufferFormat_Data::Validate), new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)));
  mojo::internal::Serialize<mojo::MapDataView<::gfx::mojom::BufferFormat, mojo::ArrayDataView<uint64_t>>>(
      in_buffer_formats_with_modifiers, buffer, &buffer_formats_with_modifiers_writer, &buffer_formats_with_modifiers_validate_params,
      &serialization_context);
  params->buffer_formats_with_modifiers.Set(
      buffer_formats_with_modifiers_writer.is_null() ? nullptr : buffer_formats_with_modifiers_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->buffer_formats_with_modifiers.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null buffer_formats_with_modifiers in WaylandBufferManagerGpu.Initialize request");
  params->supports_dma_buf = in_supports_dma_buf;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerGpu::Name_);
  message.set_method_name("Initialize");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerGpuProxy::OnSubmission(
    ::gfx::AcceleratedWidget in_widget, uint32_t in_buffer_id, ::gfx::SwapResult in_swap_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerGpu::OnSubmission");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerGpu_OnSubmission_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerGpu_OnSubmission_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in WaylandBufferManagerGpu.OnSubmission request");
  params->buffer_id = in_buffer_id;
  mojo::internal::Serialize<::gfx::mojom::SwapResult>(
      in_swap_result, &params->swap_result);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerGpu::Name_);
  message.set_method_name("OnSubmission");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void WaylandBufferManagerGpuProxy::OnPresentation(
    ::gfx::AcceleratedWidget in_widget, uint32_t in_buffer_id, const ::gfx::PresentationFeedback& in_feedback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "ui::ozone::mojom::WaylandBufferManagerGpu::OnPresentation");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kWaylandBufferManagerGpu_OnPresentation_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::ui::ozone::mojom::internal::WaylandBufferManagerGpu_OnPresentation_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->widget)::BaseType::BufferWriter
      widget_writer;
  mojo::internal::Serialize<::gfx::mojom::AcceleratedWidgetDataView>(
      in_widget, buffer, &widget_writer, &serialization_context);
  params->widget.Set(
      widget_writer.is_null() ? nullptr : widget_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->widget.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null widget in WaylandBufferManagerGpu.OnPresentation request");
  params->buffer_id = in_buffer_id;
  typename decltype(params->feedback)::BaseType::BufferWriter
      feedback_writer;
  mojo::internal::Serialize<::gfx::mojom::PresentationFeedbackDataView>(
      in_feedback, buffer, &feedback_writer, &serialization_context);
  params->feedback.Set(
      feedback_writer.is_null() ? nullptr : feedback_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->feedback.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null feedback in WaylandBufferManagerGpu.OnPresentation request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WaylandBufferManagerGpu::Name_);
  message.set_method_name("OnPresentation");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool WaylandBufferManagerGpuStubDispatch::Accept(
    WaylandBufferManagerGpu* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kWaylandBufferManagerGpu_Initialize_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::Initialize",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::Initialize");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerGpu_Initialize_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerGpu_Initialize_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      mojo::PendingRemote<WaylandBufferManagerHost> p_remote_host{};
      base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>> p_buffer_formats_with_modifiers{};
      bool p_supports_dma_buf{};
      WaylandBufferManagerGpu_Initialize_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_remote_host =
            input_data_view.TakeRemoteHost<decltype(p_remote_host)>();
      }
      if (success && !input_data_view.ReadBufferFormatsWithModifiers(&p_buffer_formats_with_modifiers))
        success = false;
      if (success)
        p_supports_dma_buf = input_data_view.supports_dma_buf();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerGpu::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Initialize(
std::move(p_remote_host), 
std::move(p_buffer_formats_with_modifiers), 
std::move(p_supports_dma_buf));
      return true;
    }
    case internal::kWaylandBufferManagerGpu_OnSubmission_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::OnSubmission",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::OnSubmission");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerGpu_OnSubmission_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerGpu_OnSubmission_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::gfx::AcceleratedWidget p_widget{};
      uint32_t p_buffer_id{};
      ::gfx::SwapResult p_swap_result{};
      WaylandBufferManagerGpu_OnSubmission_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadWidget(&p_widget))
        success = false;
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (success && !input_data_view.ReadSwapResult(&p_swap_result))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerGpu::Name_, 835653156, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnSubmission(
std::move(p_widget), 
std::move(p_buffer_id), 
std::move(p_swap_result));
      return true;
    }
    case internal::kWaylandBufferManagerGpu_OnPresentation_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::OnPresentation",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)ui::ozone::mojom::WaylandBufferManagerGpu::OnPresentation");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::WaylandBufferManagerGpu_OnPresentation_Params_Data* params =
          reinterpret_cast<internal::WaylandBufferManagerGpu_OnPresentation_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::gfx::AcceleratedWidget p_widget{};
      uint32_t p_buffer_id{};
      ::gfx::PresentationFeedback p_feedback{};
      WaylandBufferManagerGpu_OnPresentation_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadWidget(&p_widget))
        success = false;
      if (success)
        p_buffer_id = input_data_view.buffer_id();
      if (success && !input_data_view.ReadFeedback(&p_feedback))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WaylandBufferManagerGpu::Name_, 1224948730, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnPresentation(
std::move(p_widget), 
std::move(p_buffer_id), 
std::move(p_feedback));
      return true;
    }
  }
  return false;
}

// static
bool WaylandBufferManagerGpuStubDispatch::AcceptWithResponder(
    WaylandBufferManagerGpu* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kWaylandBufferManagerGpu_Initialize_Name: {
      break;
    }
    case internal::kWaylandBufferManagerGpu_OnSubmission_Name: {
      break;
    }
    case internal::kWaylandBufferManagerGpu_OnPresentation_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWaylandBufferManagerGpuValidationInfo[] = {
    {internal::kWaylandBufferManagerGpu_Initialize_Name,
     {&internal::WaylandBufferManagerGpu_Initialize_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerGpu_OnSubmission_Name,
     {&internal::WaylandBufferManagerGpu_OnSubmission_Params_Data::Validate,
      nullptr /* no response */}},
    {internal::kWaylandBufferManagerGpu_OnPresentation_Name,
     {&internal::WaylandBufferManagerGpu_OnPresentation_Params_Data::Validate,
      nullptr /* no response */}},
};

bool WaylandBufferManagerGpuRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::ui::ozone::mojom::WaylandBufferManagerGpu::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWaylandBufferManagerGpuValidationInfo);
}

}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif