// ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_MOJOM_WAYLAND_WAYLAND_BUFFER_MANAGER_MOJOM_H_
#define UI_OZONE_PUBLIC_MOJOM_WAYLAND_WAYLAND_BUFFER_MANAGER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom-shared.h"
#include "ui/ozone/public/mojom/wayland/wayland_buffer_manager.mojom-forward.h"
#include "mojo/public/mojom/base/file_path.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-forward.h"
#include "ui/gfx/mojom/accelerated_widget.mojom-forward.h"
#include "ui/gfx/mojom/presentation_feedback.mojom-forward.h"
#include "ui/gfx/mojom/swap_result.mojom-forward.h"
#include "ui/gfx/mojom/buffer_types.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace ui {
namespace ozone {
namespace mojom {

class WaylandBufferManagerHostProxy;

template <typename ImplRefTraits>
class WaylandBufferManagerHostStub;

class WaylandBufferManagerHostRequestValidator;


class  WaylandBufferManagerHost
    : public WaylandBufferManagerHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = WaylandBufferManagerHostInterfaceBase;
  using Proxy_ = WaylandBufferManagerHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = WaylandBufferManagerHostStub<ImplRefTraits>;

  using RequestValidator_ = WaylandBufferManagerHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kSetWaylandBufferManagerGpuMinVersion = 0,
    kCreateDmabufBasedBufferMinVersion = 0,
    kCreateShmBasedBufferMinVersion = 0,
    kDestroyBufferMinVersion = 0,
    kCommitBufferMinVersion = 0,
  };
  virtual ~WaylandBufferManagerHost() {}

  
  virtual void SetWaylandBufferManagerGpu(mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> buffer_manager_gpu_associated) = 0;

  
  virtual void CreateDmabufBasedBuffer(mojo::PlatformHandle dmabuf_fd, const ::gfx::Size& size, const std::vector<uint32_t>& strides, const std::vector<uint32_t>& offsets, const std::vector<uint64_t>& modifiers, uint32_t format, uint32_t planes_count, uint32_t buffer_id) = 0;

  
  virtual void CreateShmBasedBuffer(mojo::PlatformHandle shm_fd, uint64_t length, const ::gfx::Size& size, uint32_t buffer_id) = 0;

  
  virtual void DestroyBuffer(::gfx::AcceleratedWidget widget, uint32_t buffer_id) = 0;

  
  virtual void CommitBuffer(::gfx::AcceleratedWidget widget, uint32_t buffer_id, const ::gfx::Rect& damage_region) = 0;
};

class WaylandBufferManagerGpuProxy;

template <typename ImplRefTraits>
class WaylandBufferManagerGpuStub;

class WaylandBufferManagerGpuRequestValidator;


class  WaylandBufferManagerGpu
    : public WaylandBufferManagerGpuInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = WaylandBufferManagerGpuInterfaceBase;
  using Proxy_ = WaylandBufferManagerGpuProxy;

  template <typename ImplRefTraits>
  using Stub_ = WaylandBufferManagerGpuStub<ImplRefTraits>;

  using RequestValidator_ = WaylandBufferManagerGpuRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kInitializeMinVersion = 0,
    kOnSubmissionMinVersion = 0,
    kOnPresentationMinVersion = 0,
  };
  virtual ~WaylandBufferManagerGpu() {}

  
  virtual void Initialize(mojo::PendingRemote<WaylandBufferManagerHost> remote_host, const base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>>& buffer_formats_with_modifiers, bool supports_dma_buf) = 0;

  
  virtual void OnSubmission(::gfx::AcceleratedWidget widget, uint32_t buffer_id, ::gfx::SwapResult swap_result) = 0;

  
  virtual void OnPresentation(::gfx::AcceleratedWidget widget, uint32_t buffer_id, const ::gfx::PresentationFeedback& feedback) = 0;
};



class  WaylandBufferManagerHostProxy
    : public WaylandBufferManagerHost {
 public:
  using InterfaceType = WaylandBufferManagerHost;

  explicit WaylandBufferManagerHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetWaylandBufferManagerGpu(mojo::PendingAssociatedRemote<WaylandBufferManagerGpu> buffer_manager_gpu_associated) final;
  
  void CreateDmabufBasedBuffer(mojo::PlatformHandle dmabuf_fd, const ::gfx::Size& size, const std::vector<uint32_t>& strides, const std::vector<uint32_t>& offsets, const std::vector<uint64_t>& modifiers, uint32_t format, uint32_t planes_count, uint32_t buffer_id) final;
  
  void CreateShmBasedBuffer(mojo::PlatformHandle shm_fd, uint64_t length, const ::gfx::Size& size, uint32_t buffer_id) final;
  
  void DestroyBuffer(::gfx::AcceleratedWidget widget, uint32_t buffer_id) final;
  
  void CommitBuffer(::gfx::AcceleratedWidget widget, uint32_t buffer_id, const ::gfx::Rect& damage_region) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  WaylandBufferManagerGpuProxy
    : public WaylandBufferManagerGpu {
 public:
  using InterfaceType = WaylandBufferManagerGpu;

  explicit WaylandBufferManagerGpuProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Initialize(mojo::PendingRemote<WaylandBufferManagerHost> remote_host, const base::flat_map<::gfx::BufferFormat, std::vector<uint64_t>>& buffer_formats_with_modifiers, bool supports_dma_buf) final;
  
  void OnSubmission(::gfx::AcceleratedWidget widget, uint32_t buffer_id, ::gfx::SwapResult swap_result) final;
  
  void OnPresentation(::gfx::AcceleratedWidget widget, uint32_t buffer_id, const ::gfx::PresentationFeedback& feedback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WaylandBufferManagerHostStubDispatch {
 public:
  static bool Accept(WaylandBufferManagerHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WaylandBufferManagerHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WaylandBufferManagerHost>>
class WaylandBufferManagerHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WaylandBufferManagerHostStub() {}
  ~WaylandBufferManagerHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WaylandBufferManagerGpuStubDispatch {
 public:
  static bool Accept(WaylandBufferManagerGpu* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WaylandBufferManagerGpu* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WaylandBufferManagerGpu>>
class WaylandBufferManagerGpuStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WaylandBufferManagerGpuStub() {}
  ~WaylandBufferManagerGpuStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerGpuStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WaylandBufferManagerGpuStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WaylandBufferManagerHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WaylandBufferManagerGpuRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {

}  // namespace mojo

#endif  // UI_OZONE_PUBLIC_MOJOM_WAYLAND_WAYLAND_BUFFER_MANAGER_MOJOM_H_